﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PagingWithBindingNavigator
{
    public class PageBoundries
    {

        int CurrentPage = 1;


        public void DeterminePageBoundaries(int totalRecord, int RowsPerPage, string NavClicked, out string RecordID1, out string RecordID2)
        {
            int TotalRowCount = totalRecord;
            // تعداد رکورد های که در هر صفحه باید نمایش داده شود
            int pageRows = RowsPerPage;
            int pages = 0;

            //If the rows per page are less than the total row count do the following:
            if (pageRows < TotalRowCount)
            {
                //If the Modulus returns > 0 then there should be another page.
                if ((TotalRowCount % pageRows) > 0)
                {
                    pages = ((TotalRowCount / pageRows) + 1);
                }
                else
                {
                    //There is nothing left after the Modulus, so the pageRows divide exactly...
                    //...into TotalRowCount leaving no rest, thus no extra page needs to be addd.
                    pages = TotalRowCount / pageRows;
                }
            }
            else
            {
                //If the rows per page are more than the total row count, we will obviously only ever have 1 page
                pages = 1;
            }


            //We now need to determine the LowerBoundary and UpperBoundary in order to correctly...
            //...determine the Correct RecordID's to use in the bindingSource1.Filter property.
            int LowerBoundary = 0;
            int UpperBoundary = 0;

            //We now need to know what button was clicked, if any (First, Last, Next, Previous)
            switch (NavClicked)
            {
                case "First":
                    //First clicked, the Current Page will always be 1
                    CurrentPage = 1;
                    //The LowerBoundary will thus be ((50 * 1) - (50 - 1)) = 1
                    LowerBoundary = ((pageRows * CurrentPage) - (pageRows - 1));

                    //If the rows per page are less than the total row count do the following:
                    if (pageRows < TotalRowCount)
                    {
                        UpperBoundary = (pageRows * CurrentPage);
                    }
                    else
                    {
                        //If the rows per page are more than the total row count do the following:
                        //There is only one page, so get the total row count as an UpperBoundary
                        UpperBoundary = TotalRowCount;
                    }

                    //Now using these boundaries, get the appropriate RecordID's (min & max)...
                    //...for this specific page.
                    //Remember, .NET is 0 based, so subtract 1 from both boundaries
                    RecordID1 = LowerBoundary.ToString();
                    RecordID2 = UpperBoundary.ToString();


                    break;

                case "Last":
                    //Last clicked, the CurrentPage will always be = to the variable pages
                    CurrentPage = pages;
                    LowerBoundary = ((pageRows * CurrentPage) - (pageRows - 1));
                    //The UpperBoundary will always be the sum total of all the rows
                    UpperBoundary = TotalRowCount;
                    //Now using these boundaries, get the appropriate RecordID's (min & max)...
                    //...for this specific page.
                    //Remember, .NET is 0 based, so subtract 1 from both boundaries
                    RecordID1 = LowerBoundary.ToString();
                    RecordID2 = UpperBoundary.ToString();


                    break;

                case "Next":
                    //Next clicked
                    if (CurrentPage != pages)
                    {
                        //If we arent on the last page already, add another page
                        CurrentPage += 1;
                    }

                    LowerBoundary = ((pageRows * CurrentPage) - (pageRows - 1));

                    if (CurrentPage == pages)
                    {
                        //If we are on the last page, the UpperBoundary will always be the sum total of all the rows
                        UpperBoundary = TotalRowCount;
                    }
                    else
                    {
                        //Else if we have a pageRow of 50 and we are on page 3, the UpperBoundary = 150
                        UpperBoundary = (pageRows * CurrentPage);
                    }

                    //Now using these boundaries, get the appropriate RecordID's (min & max)...
                    //...for this specific page.
                    //Remember, .NET is 0 based, so subtract 1 from both boundaries
                    RecordID1 = LowerBoundary.ToString();
                    RecordID2 = UpperBoundary.ToString();


                    break;

                case "Previous":
                    //Previous clicked
                    if (CurrentPage != 1)
                    {
                        //If we aren't on the first page already, subtract 1 from the CurrentPage
                        CurrentPage -= 1;
                    }
                    //Get the LowerBoundary
                    LowerBoundary = ((pageRows * CurrentPage) - (pageRows - 1));

                    if (pageRows < TotalRowCount)
                    {
                        UpperBoundary = (pageRows * CurrentPage);
                    }
                    else
                    {
                        UpperBoundary = TotalRowCount;
                    }

                    //Now using these boundaries, get the appropriate RecordID's (min & max)...
                    //...for this specific page.
                    //Remember, .NET is 0 based, so subtract 1 from both boundaries
                    RecordID1 = LowerBoundary.ToString();
                    RecordID2 = UpperBoundary.ToString();


                    break;

                default:
                    //No button was clicked.
                    LowerBoundary = ((pageRows * CurrentPage) - (pageRows - 1));

                    //If the rows per page are less than the total row count do the following:
                    if (pageRows < TotalRowCount)
                    {
                        UpperBoundary = (pageRows * CurrentPage);
                    }
                    else
                    {
                        //If the rows per page are more than the total row count do the following:
                        //Therefore there is only one page, so get the total row count as an UpperBoundary
                        UpperBoundary = TotalRowCount;
                    }

                    //Now using these boundaries, get the appropriate RecordID's (min & max)...
                    //...for this specific page.
                    //Remember, .NET is 0 based, so subtract 1 from both boundaries
                    RecordID1 = LowerBoundary.ToString();
                    RecordID2 = UpperBoundary.ToString();

                    break;
            }




        }
 
    }
}
